=== debian/changelog ===
marble (4:21.12.3-0ubuntu1) jammy; urgency=medium

  * New upstream release (21.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Mar 2022 10:19:10 +0000

marble (4:21.12.2-0ubuntu1) jammy; urgency=medium

  [ José Manuel Santamaría Lema ]
  * Update upstream signing key

  [ Rik Mills ]
  * New upstream release (21.12.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Feb 2022 07:25:45 +0000

marble (4:21.12.1-0ubuntu1) jammy; urgency=medium

  * New upstream release (21.12.1)
  * Install desktop files.

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Jan 2022 10:33:34 +0000

marble (4:21.12.0-0ubuntu1) jammy; urgency=medium

  [ Rik Mills ]
  * New upstream release (21.12.0)
  * Set maintainer to Kubuntu Developers.

  [ José Manuel Santamaría Lema ]
  * Update upstream signing key

 -- Rik Mills <rikmills@kde.org>  Thu, 09 Dec 2021 11:30:39 +0000

marble (4:21.11.90-0ubuntu2) jammy; urgency=medium

  * Add Kubuntu Vcs fields.

 -- Rik Mills <rikmills@kde.org>  Sun, 28 Nov 2021 19:13:28 +0000

marble (4:21.11.90-0ubuntu1) jammy; urgency=medium

  * New upstream (RC) release (21.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 26 Nov 2021 13:25:59 +0000

marble (4:21.11.80-0ubuntu1) jammy; urgency=medium

  * New upstream (beta) release (21.11.80)
  * Refresh patch do_not_install_private_headers
  * Update install files.
  * Update symbols.

 -- Rik Mills <rikmills@kde.org>  Sun, 21 Nov 2021 18:32:42 +0000

marble (4:21.08.3-1ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add qtwebengine5-dev to build depends, only for the debian
      architectures where qtwebengine is being built
    - Update symbols files
    - Add some webkit related headers to do_not_install_private_headers
    - Add qtwebengine5-dev to libmarble-dev Depends (only for architectures
      supported by qtwebengine)

 -- Rik Mills <rikmills@kde.org>  Fri, 19 Nov 2021 07:43:10 +0000

marble (4:21.08.3-0ubuntu1) jammy; urgency=medium

  [ José Manuel Santamaría Lema ]
  * New upstream release (21.08.2)

  [ Rik Mills ]
  * New upstream release (21.08.3)

 -- Rik Mills <rikmills@kde.org>  Mon, 15 Nov 2021 09:48:12 +0000
